<?php
  /**
   * Gallery
   *
   * @package Wojo Framework
   * @author wojoscripts.com
   * @copyright 2018
   * @version $Id: _gallery_grid.tpl.php, v1.00 2018-01-08 10:12:05 gewa Exp $
   */
  if (!defined("_WOJO"))
      die('Direct access to this location is not allowed.');
?>
<div class="row gutters align-middle">
  <div class="column mobile-100 phone-100">
    <h3><?php echo Lang::$word->_MOD_GA_TITLE;?></h3>
    <p class="wojo small text"><?php echo Lang::$word->_MOD_GA_SUB;?></p>
  </div>
  <div class="column shrink mobile-100 phone-100">
    <a href="<?php echo Url::url(Router::$path, "new/");?>" class="wojo secondary button"><i class="icon plus alt"></i>
      <?php echo Lang::$word->_MOD_GA_NEW;?></a>
  </div>
  <div class="column shrink">
    <a class="wojo small basic icon button" id="reorder"><i class="icon apps"></i></a>
  </div>
</div>
<div class="hide-all" id="dragNotice"><p class="content-center wojo primary semi icon text middle"> <i class="icon info sign"></i> Drag images around to sort</p></div>
<div class="wojo big space divider"></div>
<?php if(!$this->data):?>
<div class="content-center"><img src="<?php echo ADMINVIEW;?>/images/notfound.png" alt="">
  <p class="wojo small thick caps text"><?php echo Lang::$word->_MOD_GA_NOGAL;?></p>
</div>
<?php else:?>
<div class="wojo mason" id="sortable">
  <?php foreach($this->data as $row):?>
  <div class="item" id="item_<?php echo $row->id;?>" data-id="<?php echo $row->id;?>">
    <div class="wojo attached card">
      <div class="image photo"><img src="<?php echo $row->poster ? FMODULEURL . 'gallery/data/' . $row->dir. '/thumbs/' . $row->poster : UPLOADURL . '/blank.jpg';?>" class="wojo basic rounded image"></div>
      <div class="content-center">
        <h4 class="header"><?php echo $row->{'title' . Lang::$lang};?></h4>
        <a class="wojo positive icon button" href="<?php echo Url::url(Router::$path, "edit/" . $row->id);?>"><i class="icon pencil"></i></a>
        <a data-set='{"option":[{"delete": "deleteGallery","title": "<?php echo Validator::sanitize($row->{'title' . Lang::$lang}, "chars");?>","id":<?php echo $row->id;?>, "dir":"<?php echo $row->dir;?>"}],"action":"delete","parent":"#item_<?php echo $row->id;?>","url":"modules_/gallery"}' class="wojo negative icon button action"><i class="icon trash"></i></a>
      </div>
      <div class="content">
        <div class="row align-middle">
          <div class="column">
            <a href="<?php echo Url::url(Router::$path, "photos/" . $row->id);?>" class="wojo small button">
              <?php echo Lang::$word->_MOD_GA_PHOTOS;?>
              <?php echo $row->pics;?>
            </a>
          </div>
          <div class="column content-right">
            <div class="wojo small basic passive button">
              <?php echo Lang::$word->LIKES;?>
              <?php echo $row->likes;?>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <?php endforeach;?>
</div>
<?php endif;?>